//+------------------------------------------------------------------+
//|                                            Export RSI values.mq4 |
//+------------------------------------------------------------------+

#property  indicator_chart_window

#include <hanover --- function header (np).mqh>

extern   string   Symbols             = "GU,UF,EU,UJ,UC,NU,AU,AN,AC,AF,AJ,CJ,FJ,EG,EA,EF,EJ,EN,EC,GF,GA,GC,GJ,GN,NJ,NC,CF,NF";
extern   string   Suffix              = "";
extern   string   OutputFileName      = "Exported_RSI_values.csv";
extern   string   RefreshPeriod       = "+0";
extern   string   RSI_TFs             = "H4,D1,W1,MN";
extern   string   RSI_periods         = "2,9";
extern   int      RSI_applied_price   = PRICE_CLOSE;
extern   int      RSI_shiftback       = 0;


datetime   prev_time;
string     arr[20], symb[100], IndiName, RSITF[9];
int        vis, RefreshEveryXMins, nsymb, nRSIP, nRSITF, RSIP[10];
bool       FirstTime;

//+------------------------------------------------------------------+
int deinit()  {
//+------------------------------------------------------------------+
  del_obj();
  return(0);
}

//+------------------------------------------------------------------+
void del_obj()  {
//+------------------------------------------------------------------+
  int k=0;
  while (k<ObjectsTotal())   {
    string objname = ObjectName(k);
    if (StringSubstr(objname,0,StringLen(IndiName)) == IndiName)  
      ObjectDelete(objname);
    else
      k++;
  }    
  return(0);
}

//+------------------------------------------------------------------+
int init()  {
//+------------------------------------------------------------------+
  IndiName = "Export RSI values-";
  IndicatorShortName(IndiName);

  nsymb = StrToStringArray(Symbols,symb);
  for (int i=0; i<nsymb; i++)
    symb[i] = ExpandCcy(symb[i]);

  nRSITF = StrToStringArray(RSI_TFs,RSITF);
  nRSIP  = StrToIntegerArray(RSI_periods,RSIP);
  
  RefreshEveryXMins = StrToTF(RefreshPeriod);
  prev_time = -9999;
  
  del_obj();
  plot_obj();
  return(0);
}

//+------------------------------------------------------------------+
int start()  {
//+------------------------------------------------------------------+
  if (RefreshEveryXMins < 0)  {
    if (FirstTime)  {
      del_obj();
      plot_obj();
    }
    FirstTime = false;      
    return(0);
  }  
  if (RefreshEveryXMins == 0) {
    del_obj();
    plot_obj();    
  } else {
    if (prev_time != iTime(Symbol(),RefreshEveryXMins,0))  {
      del_obj();
      plot_obj();
      prev_time = iTime(Symbol(),RefreshEveryXMins,0);
  } }      
  return(0);
}

//+------------------------------------------------------------------+
int plot_obj()  {
//+------------------------------------------------------------------+
  int h = FileOpen(OutputFileName,FILE_WRITE|FILE_CSV,',');
  if (h==0)    return(0);
  for (int i=0; i<nsymb; i++)  {
    double RSItotal=0;
    for (int j=0; j<nRSITF; j++)  {
      for (int k=0; k<nRSIP; k++)   {
        RSItotal += iRSI(symb[i]+Suffix, StrToTF(RSITF[j]), RSIP[k], RSI_applied_price, RSI_shiftback);
    } }
    double RSI = DivZero(RSItotal,nRSITF*nRSIP);
//    string mask = "TR5." + NumberToStr(MarketInfo(symb[i]+Suffix,MODE_DIGITS),"1");
    FileWrite(h,symb[i],TimeToStr(iTime(symb[i]+Suffix,StrToTF(RSITF[0]),RSI_shiftback),TIME_DATE|TIME_SECONDS),NumberToStr(RSI,"TR5.5"));
  }
  FileClose(h);
  return(0);
}

//+------------------------------------------------------------------+
#include <hanover --- extensible functions (np).mqh>

