//+------------------------------------------------------------------+
//|                              Plot External Data (main chart).mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
//#property indicator_separate_window

#include <hanover --- function header (np).mqh>

#property  indicator_buffers 1
#property  indicator_color1  Red
#property  indicator_width1  1

extern   string   FileName         = "data.csv";
//extern   string   FileName         = "indicator_[sym].csv";
extern   string   DateFormat       = "YYYY.MM.DD HH:II";
extern   string   DateDelimiters   = ". :";
extern   string   FieldDelimiter   = ",";
extern   string   _1               = "Color, Width, Style";
extern   string   LineSettings     = "Red,1,0";
//extern   string   LineSettings     = "White,2,0";
extern   string   MaximumValue     = "";
extern   string   MinimumValue     = "";
extern   string   ShowMinMaxValues = ",10,20,Verdana,10,White,'Min='TR-6.5'; ','Max='TR-6.5";
extern   string   YaxisValues      = "";                       // e.g. if YaxisValues = "*,-30,10,30" (from -30, incr +10, stop at +30) then convert it to "-30,-20,-10,0,10,20,30"
extern   string   _2               = "Start candle, Length, Color, Width, Style, Mask";
extern   string   YaxisSettings    = "-2,5,Gray,1,2,T-5";      // if StartCandle is blank, set to left of chart; if Length is blank, set it to negative value (creates a ray)
extern   string   Visibility       = "M1,M5,M15,M30,H1,H4,D1,W1,MN";
extern   string   RefreshPeriod    = "+0";
extern   bool     ShowDataAtClose  = false;

/*
extern   string   FileName         = "usdstr.csv";
extern   string   MaximumValue     = "120";
extern   string   MinimumValue     = "-120";
extern   string   YaxisValues      = "-100,-80,-60,-40,-20,0,20,40,60,80,100";
extern   string   YaxisSettings    = "-2,5,Gray,1,2,T-5";
*/
double     buffer0[];

datetime   dt[9999], prev_time;
double     val[9999], Yax[50];
string     arr[4], Yset[10], Lset[10], IndiName, mmv[10], FontMMV, MaskMin, MaskMax; 
int        nY, vis, RefreshEveryXMins, LineWidth, LineStyle, ShowMMV, HposMMV, VposMMV, SizeMMV;
bool       FirstTime;
color      LineColor, ColorMMV;

//+------------------------------------------------------------------+
int deinit()  {
//+------------------------------------------------------------------+
  del_obj();
  return(0);
}

//+------------------------------------------------------------------+
void del_obj()  {
//+------------------------------------------------------------------+
  int k=0;
  while (k<ObjectsTotal())   {
    string objname = ObjectName(k);
    if (StringSubstr(objname,0,StringLen(IndiName)) == IndiName)  
      ObjectDelete(objname);
    else
      k++;
  }    
  return(0);
}

//+------------------------------------------------------------------+
int init()  {
//+------------------------------------------------------------------+
  FileName = StringReplace(FileName,"[sym]",Symbol());
  FileName = StringReplace(FileName,"[tf]",Period());
  FileName = StringReplace(FileName,"[dt]",DateToStr(TimeCurrent(),"Y-M-D_H-I-S"));
  IndiName = "PEDmc[" + FileName + "]-";

  StrToStringArray(YaxisSettings,Yset);

  StrToStringArray(LineSettings,Lset);
  LineColor = StrToColor(Lset[0]);
  LineWidth = StrToInteger(Lset[1]);
  LineStyle = StrToInteger(Lset[2]);

  StrToStringArray(ShowMinMaxValues,mmv);
  if (StringLen(mmv[0])<1)   
    ShowMMV = -1;
  else  
    ShowMMV  = 2*(StringFind(StringUpper(mmv[0]),"B")>=0) + (StringFind(StringUpper(mmv[0]),"R")>=0);
  HposMMV  = StrToInteger(mmv[1]);
  VposMMV  = StrToInteger(mmv[2]);
  FontMMV  = mmv[3];
  SizeMMV  = StrToInteger(mmv[4]);
  if (StringLen(mmv[5])<1)
    ColorMMV = LineColor;
  else  
    ColorMMV = StrToColor(mmv[5]);
  MaskMin  = mmv[6];
  MaskMax  = mmv[7];

  SetIndexBuffer(0,buffer0);
  SetIndexStyle(0,DRAW_LINE,LineStyle,LineWidth,LineColor);
  SetIndexDrawBegin(0,0);
  IndicatorShortName("External: "+FileName);

  RefreshEveryXMins = StrToTF(RefreshPeriod);
  prev_time = -9999;
  vis = GetVisibility(Visibility);
  
  del_obj();
  plot_obj();
  return(0);
}

//+------------------------------------------------------------------+
int start()  {
//+------------------------------------------------------------------+
  if (RefreshEveryXMins < 0)  {
    if (FirstTime)  {
      del_obj();
      plot_obj();
    }
    FirstTime = false;      
    return(0);
  }  
  if (RefreshEveryXMins == 0) {
    del_obj();
    plot_obj();    
  } else {
    if (prev_time != iTime(Symbol(),RefreshEveryXMins,0))  {
      del_obj();
      plot_obj();
      prev_time = iTime(Symbol(),RefreshEveryXMins,0);
  } }      
  return(0);
}

//+------------------------------------------------------------------+
int plot_obj()  {
//+------------------------------------------------------------------+
  if (StringFind(Visibility+",",TFToStr(Period())+",")<0)
    return(0);
//  Comment(DateToStr(TimeCurrent(),"w D n Y  H:I:S"));  

  int h = FileOpen(FileName, FILE_CSV|FILE_READ,'~');
  if (h==0) {
    Comment("File "+FileName+" not found.");
    return(0);
  }  

  // First pass loads data from file into arrays dt, val   (i.e. date/time, and value)
  double MaxValue = -99999999;
  double MinValue = 99999999;
  for (int c=0; !FileIsEnding(h) && c<9999; c++)  {
    string tmp = FileReadString(h);
    if (FileIsEnding(h))  break;
    if (StringLen(StringTrimRight(tmp)) < 1)   continue;    // ignore blank lines
    StrToStringArray(tmp,arr,FieldDelimiter);
    dt[c]  = StrToDate(arr[0],DateFormat,DateDelimiters);
    val[c] = StrToNumber(arr[1]);
    MinValue = MathMin(val[c],MinValue);
    MaxValue = MathMax(val[c],MaxValue);
//    if (c>0)  d("pass1",c,DateToStr(dt[c]),NumberToStr(val[c],"RT-3.5"));    // debugging only
  }
  FileClose(h);
  if (StringLen(ShowMinMaxValues)>0 && ShowMMV>=0)  {
    string TextMMV = NumberToStr(MinValue,MaskMin) + NumberToStr(MaxValue,MaskMax);
    PlotLabel (IndiName+NumberToStr(9999,"'-'Z6"), true, 0, ShowMMV, HposMMV, VposMMV, TextMMV, ColorMMV, SizeMMV, FontMMV, 0.0, false, vis);       // Plot text label
  }

  if (StringLen(MinimumValue)>0)        MinValue=StrToNumber(MinimumValue);   // override by defaults (if entered)
  if (StringUpper(MinimumValue)=="P")   MinValue=WindowPriceMin();
  if (StringLen(MaximumValue)>0)        MaxValue=StrToNumber(MaximumValue);
  if (StringUpper(MaximumValue)=="P")   MaxValue=WindowPriceMax();

  // Second pass re-synchs data from dt, val arrays onto chart timeframe, and plots them accordingly
  c--;
  for (int i=0; i<=Bars; i++)  {
    datetime tim = Time[i];
    if (ShowDataAtClose && i>0)
      tim = Time[i-1]-1;
    if (ShowDataAtClose && i==0)
      tim = TimeCurrent();
    while(tim<dt[c]) c--;
    if (c>=0)  {
       double pval = DivZero(val[c]-MinValue,MaxValue-MinValue)*(WindowPriceMax()-WindowPriceMin()) + WindowPriceMin();
       buffer0[i] = NormalizeDouble(pval,Digits);
//       d(i,c,val[c],MinValue,MaxValue,WindowPriceMin(),WindowPriceMax(),pval,MinimumValue,MaximumValue);
    }   
//    if (i<30) d("pass2",i,DateToStr(Time[i]),c,DateToStr(dt[c]),val[c],buffer0[i],MinValue,MaxValue,WindowPriceMin(),WindowPriceMax(),c,pval);    // debugging only
  }
  
  // Calc Y-axis values........
  if (StringSubstr(YaxisValues,0,1)=="?")  {
    nY = StrToDoubleArray(YaxisValues,Yax);
    int Yinc = 11;
    if (Yax[1]>0)  Yinc = Yax[1];
    YaxisValues = "*," + NumberToStr(MinValue,Yset[5]+"','") + NumberToStr((MaxValue-MinValue)/Yinc,Yset[5]+"','") + NumberToStr(MaxValue,Yset[5]);
  }
  nY = StrToDoubleArray(YaxisValues,Yax);
  if (StringSubstr(YaxisValues,0,1)=="*")  {       // e.g. if YaxisValues = "*,-30,10,30" (from -30, incr +10, stop at +30) then convert it to "-30,-20,-10,0,10,20,30"
    YaxisValues = "";
    for (double z=Yax[1]; z<=Yax[3]; z+=Yax[2])  {
      YaxisValues = AppendIfNotNull(YaxisValues,",") + NumberToStr(z,Yset[5]);
    }  
    nY = StrToDoubleArray(YaxisValues,Yax);
  }

  // plot y-axis.......
  int       Ystart   = StrToInteger(Yset[0]);
  int       Yleng    = StrToInteger(Yset[1]);
  if (StringLen(Yset[0])<1)   Ystart = WindowBarsPerChart();
  if (StringLen(Yset[1])<1)   Yleng  = -WindowBarsPerChart();
  color     Ycolor   = StrToColor(Yset[2]);
  int       Ywidth   = StrToInteger(Yset[3]);
  int       Ystyle   = StrToInteger(Yset[4]);
  string    Ymask    = Yset[5];
  bool      Yray     = (Yleng<0);
            Yleng    = MathAbs(Yleng);
  datetime  Ytim0    = Time[0]-Ystart*60*Period();
  datetime  Ytim1    = Time[0]-(Ystart-MathMax(Yleng,1))*60*Period();
  if (Yray)
    Ytim1 = Time[0];
  
  if (StringLen(YaxisValues)>0 && StringLen(YaxisSettings)>0)   {
    for (int y=0; y<nY; y++)  {
      double yval = DivZero(Yax[y]-MinValue,MaxValue-MinValue)*(WindowPriceMax()-WindowPriceMin()) + WindowPriceMin();
      string objname = IndiName + NumberToStr(y,"Z2");
      if (StringLen(Yset[0])<1)   
        PlotHL (objname, true, 0, yval, Ycolor, Ywidth, Ystyle, false, vis, NumberToStr(Yax[y],Ymask));      // Plot horizontal line
      else  
        PlotTL (objname, true, 0, Ytim0,  yval, Ytim1, yval, Ycolor, Ywidth, Ystyle, Yray, false, vis, NumberToStr(Yax[y],Ymask));      // Plot trendline
  } }
//  d(Ystart,Yleng,Ytim0,DateToStr(Ytim0,"Y.M.D H:I:S"),Ytim1,DateToStr(Ytim1,"Y.M.D H:I:S"));
  return(0);
}

//+------------------------------------------------------------------+
#include <hanover --- extensible functions (np).mqh>

